

EA_PLM = LibStub("AceAddon-3.0"):NewAddon("EA_PLM", "AceConsole-3.0", "AceEvent-3.0")

PLM_WAIT_FOR_ENABLE_OR_DISABLE = 1
PLM_WAIT_FOR_INSPECT = 2

PLM_ONLY_OFFER_IF_UPGRADE			= 'PLM_ONLY_OFFER_IF_UPGRADE'
PLM_CURRENT_SPEC_ONLY				= 'PLM_CURRENT_SPEC_ONLY'
PLM_ILVL_THRESHOLD					= 'PLM_ILVL_THRESHOLD'
PLM_INCLUDE_XMOG					= 'PLM_INCLUDE_XMOG'
PLM_XMOG_UP							= 'PLM_XMOG_UP'
PLM_CONF_RL_MODE					= 'PLM_RL_MODE'
PLM_CONF_USE_SW_SCORE				= 'PLM_USE_SW_SCORE'
PLM_STAT_WEIGHTS					= 'PLM_ STAT_WEIGHTS'
PLM_SCALE_VALUE						= 'PLM_SCALE_VALUE'
PLM_PROMPT_CHAT						= 'PLM_PROMPT_CHAT'
PLM_DELAY_CHAT						= 'PLM_DELAY_CHAT'
PLM_WISP_MSG						= 'PLM_WISP_MSG'


PLM_TOOLTIP_NAME					= 'PLM_TOOLTIP_NAME'

PLM_CHAT_ALWAYS						= 'PLM_CHAT_ALWAYS'
PLM_CHAT_IFRL						= 'PLM_CHAT_IFRL'
PLM_CHAT_NEVER						= 'PLM_CHAT_NEVER'

PLM_LAST_SEEN_MESSAGE_VERSION		= 'PLM_LAST_SEEN_MESSAGE_VERSION'
PLM_LOOTED_ITEMS_FRAME_X			= 'PLM_LOOTED_ITEMS_FRAME_X'
PLM_LOOTED_ITEMS_FRAME_Y			= 'PLM_LOOTED_ITEMS_FRAME_Y'
PLM_LOOTED_ITEMS_FRAME_WIDTH		= 'PLM_LOOTED_ITEMS_FRAME_WIDTH'
PLM_LOOTED_ITEMS_FRAME_HEIGHT		= 'PLM_LOOTED_ITEMS_FRAME_HEIGHT'

DELAY_BETWEEN_INSPECTIONS			= 1		-- in seconds
MIN_DELAY_BETWEEN_CACHE_REFRESHES	= 5		-- in seconds
MAX_INSPECT_LOOPS 				= 3    	-- maximum # of times to retry calling NotifyInspect on all members in the roster for whom we've cached fewer than the expected number of items

eventHandlerFrame = nil
enableOrDisableEventFrame = nil
lootedItemsFrame = nil
scrollFrame = nil
scrollbar = nil
contentFrame = nil
isEnabled = false
priorCacheRefreshTime = 0

inspectLoop = 0
inspectIndex = 0						-- index of the character we're currently inspecting
maxInspectIndex = 0  					-- the index of the last character in GetRaidRosterInfo()
notifyInspectName = nil 

radioButtons = {}						-- indexed by lootedItemID and requestorIndex
labels = {}
labelIndex = 0						-- index of the mos recently created label
buttons = {}
buttonIndex = 0						-- index of the most recently created button
itemFrames = {}
itemFrameIndex = 0

groupInfoCache = {}  					-- array of items equipped by group members; keyed by name-realm of group member
	--[[									   structure is as follows, for each group member:
		groupInfoCache[name-realm][CLASS_NAME]			group member's class name from UnitClass(), in english
		groupInfoCache[name-realm][SPEC]				group member's spec from GetInspectSpecialization()
		groupInfoCache[name-realm][LEVEL]				group member's character level
		groupInfoCache[name-realm][FORCE_REFRESH]		boolean for whether to force a refresh of this member's data during next cache refresh
		groupInfoCache[name-realm][INVSLOT_HEAD]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_NECK]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_SHOULDER]	item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_BACK]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_CHEST]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_WRIST]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_HAND]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_WAIST]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_LEGS]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_FEET]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_FINGER1]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_FINGER2]		item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_TRINKET1]	item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_TRINKET2]	item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_MAINHAND]	item link of the item equipped in this slot
		groupInfoCache[name-realm][INVSLOT_OFFHAND]		item link of the item equipped in this slot
	]]--
	
lootedItems = {}  					-- array of items looted by player; keyed by name-realm of looter
	--[[									   structure is as follows, for each looted item:
		lootedItems[lootedItemIndex][LOOTER_NAME] 				looter's full name (name-realm)
		lootedItems[lootedItemIndex][FULL_ITEM_INFO] 			full item info
		lootedItems[lootedItemIndex][STATUS] 					one of the STATUS_ options from below
	]]--
	
L = LibStub("AceLocale-3.0"):GetLocale("EA_PLM")

Config = {}
Config[PLM_CURRENT_SPEC_ONLY] = false
Config[PLM_ONLY_OFFER_IF_UPGRADE] = false
Config[PLM_INCLUDE_XMOG] = true
Config[PLM_XMOG_UP] = true
Config[PLM_ILVL_THRESHOLD] = -1
Config[PLM_CONF_RL_MODE] = false
Config[PLM_CONF_USE_SW_SCORE] = false
Config[PLM_STAT_WEIGHTS] = nil
Config[PLM_SCALE_VALUE] = nil
Config[PLM_PROMPT_CHAT] = PLM_CHAT_IFRL
Config[PLM_DELAY_CHAT] = 0
Config[PLM_WISP_MSG] = ""


function EA_PLM:OnInitialize()

self:Print("loaded")
    -- Called when the addon is loaded
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("EA_PLM", options)
	
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("EA_PLM", "EA_PLM")
	self:RegisterChatCommand("plm", "ChatCommand")
	--CreateConfigMenu
	
	eventHandlerFrame = CreateFrame('Frame')
	eventHandlerFrame:SetScript('OnEvent', ProcessEvent)
	EA_PLM:AddonLoadedEvent()
end

function EA_PLM:OnEnable()
    -- Called when the addon is enabled
	self:Print("|cffff8000 Personnal Loot Manager: Version "..GetAddOnMetadata("EA_PLM", "Version").." " .. L["INIT_LOADED"] .. ".|r")
	self:Print("|cffff8000 " .. L["INIT_LOAD_CMD"] .. ".|r")
end

function EA_PLM:OnDisable()
    -- Called when the addon is disabled
end

function EA_PLM:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(options.name)
		InterfaceOptionsFrame_OpenToCategory(options.name)
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("plm", "EA_PLM", "EA_PLM")
    end
end








--[[

--WorldOfWarcraftAddOnIntermediate:Show()

--GladiusEx = LibStub("AceAddon-3.0"):NewAddon("GladiusEx", "AceEvent-3.0")



local AceGUI = LibStub("AceGUI-3.0")
-- Create a container frame
local f = AceGUI:Create("Frame")
f:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
f:SetTitle("AceGUI-3.0 Example")
f:SetStatusText("Status Bar")
f:SetLayout("Flow")
f:Hide()
-- Create a button
local btn = AceGUI:Create("Button")
btn:SetWidth(170)
btn:SetText("Button !")
btn:SetCallback("OnClick", function() WorldOfWarcraftAddOnIntermediate:Show() end)
-- Add the button to the container
f:AddChild(btn)

]]--