plmUsers = {}

LOOTER_NAME					= 'LOOTER_NAME'
FULL_ITEM_INFO				= 'FULL_ITEM_INFO'
STATUS						= 'STATUS'
STATUS_SELF_LOOT			= 'STATUS_SELF_LOOT'
STATUS_OTHER_LOOT			= 'STATUS_OTHER_LOOT'
STATUS_RL_LOOT				= 'STATUS_RL_LOOT'
STATUS_HIDDEN				= 'STATUS_HIDDEN'
STATUS_XMOG					= 'STATUS_XMOG'

CLASS_NAME					= 'CLASS_NAME'
SPEC						= 'SPEC'
PL_LEVEL					= 'LEVEL'
FORCE_REFRESH				= 'FORCE_REFRESH'

DEATH_KNIGHT				= select(2, GetClassInfo(6))
DEMON_HUNTER				= select(2, GetClassInfo(12))
DRUID						= select(2, GetClassInfo(11))
HUNTER						= select(2, GetClassInfo(3))
MAGE						= select(2, GetClassInfo(8))
MONK						= select(2, GetClassInfo(10))
PALADIN						= select(2, GetClassInfo(2))
PRIEST						= select(2, GetClassInfo(5))
ROGUE						= select(2, GetClassInfo(4))
SHAMAN						= select(2, GetClassInfo(7))
WARLOCK						= select(2, GetClassInfo(9))
WARRIOR						= select(2, GetClassInfo(1))


stat_index = {
	["Stamina"] = "ITEM_MOD_STAMINA_SHORT",
	["Agility"] = "ITEM_MOD_AGILITY_SHORT",
	["Intellect"] = "ITEM_MOD_INTELLECT_SHORT",
	["Strength"] = "ITEM_MOD_STRENGTH_SHORT",

	["CritRating"] = "ITEM_MOD_CRIT_RATING_SHORT",
	["HasteRating"] = "ITEM_MOD_HASTE_RATING_SHORT",
	["MasteryRating"] = "ITEM_MOD_MASTERY_RATING_SHORT",
	["Versatility"] = "ITEM_MOD_VERSATILITY",
	["Dps"] = "DPS",
	["OffHandDps"] = "OFFHANDDPS",

	["Class"] = "Class",
	["Spec"] = "Spec"
}


-- Specialization IDs from http://wow.gamepedia.com/API_GetInspectSpecialization
SPEC_DK_BLOOD					= 250
SPEC_DK_FROST					= 251
SPEC_DK_UNHOLY				= 252
SPEC_DH_HAVOC					= 577
SPEC_DH_VENGEANCE				= 581
SPEC_DRUID_BALANCE			= 102
SPEC_DRUID_FERAL				= 103
SPEC_DRUID_GUARDIAN			= 104
SPEC_DRUID_RESTO				= 105
SPEC_HUNTER_BM				= 253
SPEC_HUNTER_MARKS				= 254
SPEC_HUNTER_SURVIVAL			= 255
SPEC_MAGE_ARCANE				= 62
SPEC_MAGE_FIRE				= 63
SPEC_MAGE_FROST				= 64
SPEC_MONK_BM					= 268
SPEC_MONK_MW					= 270
SPEC_MONK_WW					= 269
SPEC_PALADIN_HOLY				= 65
SPEC_PALADIN_PROT				= 66
SPEC_PALADIN_RET				= 70
SPEC_PRIEST_DISC				= 256
SPEC_PRIEST_HOLY				= 257
SPEC_PRIEST_SHADOW			= 258
SPEC_ROGUE_ASS				= 259
SPEC_ROGUE_OUTLAW				= 260
SPEC_ROGUE_SUB				= 261
SPEC_SHAMAN_ELE				= 262
SPEC_SHAMAN_ENH				= 263
SPEC_SHAMAN_RESTO				= 264
SPEC_WARLOCK_AFF				= 256
SPEC_WARLOCK_DEMO				= 266
SPEC_WARLOCK_DESTRO			= 267
SPEC_WARRIOR_ARMS				= 71
SPEC_WARRIOR_FURY				= 72
SPEC_WARRIOR_PROT				= 73

SPEC_BY_CLASS = {
	[DEATH_KNIGHT]					= { SPEC_DK_BLOOD, SPEC_DK_FROST, SPEC_DK_UNHOLY },
	[DEMON_HUNTER]					= { SPEC_DH_HAVOC, SPEC_DH_VENGEANCE },
	[DRUID]							= { SPEC_DRUID_BALANCE, SPEC_DRUID_FERAL, SPEC_DRUID_GUARDIAN, SPEC_DRUID_RESTO },
	[HUNTER]						= { SPEC_HUNTER_BM, SPEC_HUNTER_MARKS, SPEC_HUNTER_SURVIVAL },
	[MAGE]							= { SPEC_MAGE_ARCANE, SPEC_MAGE_FIRE, SPEC_MAGE_FROST },
	[MONK]							= { SPEC_MONK_BM, SPEC_MONK_MW, SPEC_MONK_WW },
	[PALADIN]						= { SPEC_PALADIN_HOLY, SPEC_PALADIN_PROT, SPEC_PALADIN_RET },
	[PRIEST]						= { SPEC_PRIEST_DISC, SPEC_PRIEST_HOLY, SPEC_PRIEST_SHADOW },
	[ROGUE]							= { SPEC_ROGUE_ASS, SPEC_ROGUE_OUTLAW, SPEC_ROGUE_SUB },
	[SHAMAN]						= { SPEC_SHAMAN_ELE, SPEC_SHAMAN_ENH, SPEC_SHAMAN_RESTO },
	[WARLOCK]						= { SPEC_WARLOCK_AFF, SPEC_WARLOCK_DEMO, SPEC_WARLOCK_DESTRO },
	[WARRIOR]						= { SPEC_WARRIOR_ARMS, SPEC_WARRIOR_FURY, SPEC_WARRIOR_PROT }
}

SPECS_EXPECTED_TO_HAVE_OFFHAND = {
	[SPEC_DK_FROST] 				= true,
	[SPEC_DH_VENGEANCE]				= true,
	[SPEC_DH_HAVOC] 				= true,
	[SPEC_MONK_WW] 					= true,
	[SPEC_PALADIN_PROT] 			= true,
	[SPEC_ROGUE_ASS] 				= true,
	[SPEC_ROGUE_OUTLAW] 			= true,
	[SPEC_ROGUE_SUB] 				= true,
	[SPEC_SHAMAN_ENH] 				= true,
	[SPEC_WARRIOR_PROT] 			= true
}

FII_ITEM						= 'ITEM'						-- item link
--local FII_NAME					= 'NAME'						-- return value 1 of Blizzard API call GetItemInfo()
--local FII_LINK					= 'LINK'						-- return value 2 of Blizzard API call GetItemInfo()
FII_QUALITY					= 'QUALITY'						-- return value 3 of Blizzard API call GetItemInfo()
FII_BASE_ILVL					= 'BASE_ILVL'					-- return value 4 of Blizzard API call GetItemInfo()
FII_REQUIRED_LEVEL			= 'REQUIRED_LEVEL'				-- return value 5 of Blizzard API call GetItemInfo()
--local FII_TYPE					= 'TYPE'						-- return value 6 of Blizzard API call GetItemInfo()
FII_SUB_TYPE				= 'SUB_TYPE'					-- return value 7 of Blizzard API call GetItemInfo()
--local FII_MAX_STACK				= 'MAX_STACK'					-- return value 8 of Blizzard API call GetItemInfo()
FII_ITEM_EQUIP_LOC			= 'ITEM_EQUIP_LOC'				-- return value 9 of Blizzard API call GetItemInfo()
--local FII_TEXTURE					= 'TEXTURE'						-- return value 10 of Blizzard API call GetItemInfo()
--local FII_VENDOR_PRICE			= 'VENDOR_PRICE'				-- return value 11 of Blizzard API call GetItemInfo()
FII_CLASS						= 'CLASS'						-- return value 12 of Blizzard API call GetItemInfo()
FII_SUB_CLASS					= 'SUB_CLASS'					-- return value 13 of Blizzard API call GetItemInfo()
FII_BIND_TYPE					= 'BIND_TYPE'					-- return value 14 of Blizzard API call GetItemInfo()
--local FII_EXPAC_ID				= 'EXPAC_ID'					-- return value 15 of Blizzard API call GetItemInfo()
--local FII_ITEM_SET_ID				= 'ITEM_SET_ID'					-- return value 16 of Blizzard API call GetItemInfo()
--local FII_IS_CRAFTING_REAGENT		= 'IS_CRAFTING_REAGENT'			-- return value 17 of Blizzard API call GetItemInfo()
FII_IS_EQUIPPABLE				= 'IS_EQUIPPABLE'				-- true if the item is equippable, false otherwise
FII_REAL_ILVL					= 'REAL_ILVL'					-- real ilvl, derived from tooltip
FII_CLASSES					= 'CLASSES'						-- uppercase string of classes that can use the item (ex: tier); nil if item is not class-restricted
FII_TRADE_TIME_WARNING_SHOWN  = 'TRADE_TIME_WARNING_SHOWN'	-- true if the 'You may trade this item...' text is in the tooltip
FII_HAS_SOCKET				= 'HAS_SOCKET'					-- true if the item has a socket
FII_HAS_AVOIDANCE				= 'HAS_AVOIDANCE'				-- true if the item has avoidance
FII_HAS_INDESTRUCTIBLE		= 'HAS_INDESTRUCTIBLE'			-- true if the item has indestructible
FII_HAS_LEECH					= 'HAS_LEECH'					-- true if the item has leech
FII_HAS_SPEED					= 'HAS_SPEED'					-- true if the item has speed
FII_XMOGGABLE					= 'XMOGGABLE'					-- true if the player needs this item for xmog

ROLE_BY_SPEC = {
	[SPEC_DK_BLOOD]					= PLH_ROLE_TANK,
	[SPEC_DK_FROST]					= PLH_ROLE_STRENGTH_DPS,
	[SPEC_DK_UNHOLY]				= PLH_ROLE_STRENGTH_DPS,
	[SPEC_DH_HAVOC]					= PLH_ROLE_AGILITY_DPS,
	[SPEC_DH_VENGEANCE]				= PLH_ROLE_TANK,
	[SPEC_DRUID_BALANCE]			= PLH_ROLE_INTELLECT_DPS,
	[SPEC_DRUID_FERAL]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_DRUID_GUARDIAN]			= PLH_ROLE_TANK,
	[SPEC_DRUID_RESTO]				= PLH_ROLE_HEALER,
	[SPEC_HUNTER_BM]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_HUNTER_MARKS]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_HUNTER_SURVIVAL]			= PLH_ROLE_AGILITY_DPS,
	[SPEC_MAGE_ARCANE]				= PLH_ROLE_INTELLECT_DPS,
	[SPEC_MAGE_FIRE]				= PLH_ROLE_INTELLECT_DPS,
	[SPEC_MAGE_FROST]				= PLH_ROLE_INTELLECT_DPS,
	[SPEC_MONK_BM]					= PLH_ROLE_TANK,
	[SPEC_MONK_MW]					= PLH_ROLE_HEALER,
	[SPEC_MONK_WW]					= PLH_ROLE_AGILITY_DPS,
	[SPEC_PALADIN_HOLY]				= PLH_ROLE_HEALER,
	[SPEC_PALADIN_PROT]				= PLH_ROLE_TANK,
	[SPEC_PALADIN_RET]				= PLH_ROLE_STRENGTH_DPS,
	[SPEC_PRIEST_DISC]				= PLH_ROLE_HEALER,
	[SPEC_PRIEST_HOLY]				= PLH_ROLE_HEALER,
	[SPEC_PRIEST_SHADOW]			= PLH_ROLE_INTELLECT_DPS,
	[SPEC_ROGUE_ASS]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_ROGUE_OUTLAW]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_ROGUE_SUB]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_SHAMAN_ELE]				= PLH_ROLE_INTELLECT_DPS,
	[SPEC_SHAMAN_ENH]				= PLH_ROLE_AGILITY_DPS,
	[SPEC_SHAMAN_RESTO]				= PLH_ROLE_HEALER,
	[SPEC_WARLOCK_AFF]				= PLH_ROLE_INTELLECT_DPS,
	[SPEC_WARLOCK_DEMO]				= PLH_ROLE_INTELLECT_DPS,
	[SPEC_WARLOCK_DESTRO]			= PLH_ROLE_INTELLECT_DPS,
	[SPEC_WARRIOR_ARMS]				= PLH_ROLE_STRENGTH_DPS,
	[SPEC_WARRIOR_FURY]				= PLH_ROLE_STRENGTH_DPS,
	[SPEC_WARRIOR_PROT]				= PLH_ROLE_TANK
}

PRIMARY_ATTRIBUTE_BY_SPEC = {
	[SPEC_DK_BLOOD]					= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_DK_FROST]					= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_DK_UNHOLY]				= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_DH_HAVOC]					= ITEM_MOD_AGILITY_SHORT,
	[SPEC_DH_VENGEANCE]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_DRUID_BALANCE]			= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_DRUID_FERAL]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_DRUID_GUARDIAN]			= ITEM_MOD_AGILITY_SHORT,
	[SPEC_DRUID_RESTO]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_HUNTER_BM]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_HUNTER_MARKS]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_HUNTER_SURVIVAL]			= ITEM_MOD_AGILITY_SHORT,
	[SPEC_MAGE_ARCANE]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_MAGE_FIRE]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_MAGE_FROST]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_MONK_BM]					= ITEM_MOD_AGILITY_SHORT,
	[SPEC_MONK_MW]					= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_MONK_WW]					= ITEM_MOD_AGILITY_SHORT,
	[SPEC_PALADIN_HOLY]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_PALADIN_PROT]				= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_PALADIN_RET]				= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_PRIEST_DISC]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_PRIEST_HOLY]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_PRIEST_SHADOW]			= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_ROGUE_ASS]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_ROGUE_OUTLAW]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_ROGUE_SUB]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_SHAMAN_ELE]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_SHAMAN_ENH]				= ITEM_MOD_AGILITY_SHORT,
	[SPEC_SHAMAN_RESTO]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_WARLOCK_AFF]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_WARLOCK_DEMO]				= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_WARLOCK_DESTRO]			= ITEM_MOD_INTELLECT_SHORT,
	[SPEC_WARRIOR_ARMS]				= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_WARRIOR_FURY]				= ITEM_MOD_STRENGTH_SHORT,
	[SPEC_WARRIOR_PROT]				= ITEM_MOD_STRENGTH_SHORT
}

-- LE_ITEM_ARMOR_GENERIC is for off hand frills in the following (they appear as LE_ITEM_CLASS_ARMOR, LE_ITEM_ARMOR_GENERIC, LE_INVENTORY_TYPE_HOLDABLE_TYPE)
EQUIPPABLE_ARMOR_BY_SPEC = {
	[SPEC_DK_BLOOD]					= { LE_ITEM_ARMOR_PLATE },
	[SPEC_DK_FROST]					= { LE_ITEM_ARMOR_PLATE },
	[SPEC_DK_UNHOLY]				= { LE_ITEM_ARMOR_PLATE },
	[SPEC_DH_HAVOC]					= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_DH_VENGEANCE]				= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_DRUID_BALANCE]			= { LE_ITEM_ARMOR_LEATHER, LE_ITEM_ARMOR_GENERIC },
	[SPEC_DRUID_FERAL]				= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_DRUID_GUARDIAN]			= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_DRUID_RESTO]				= { LE_ITEM_ARMOR_LEATHER, LE_ITEM_ARMOR_GENERIC },
	[SPEC_HUNTER_BM]				= { LE_ITEM_ARMOR_MAIL },
	[SPEC_HUNTER_MARKS]				= { LE_ITEM_ARMOR_MAIL },
	[SPEC_HUNTER_SURVIVAL]			= { LE_ITEM_ARMOR_MAIL },
	[SPEC_MAGE_ARCANE]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_MAGE_FIRE]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_MAGE_FROST]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_MONK_BM]					= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_MONK_MW]					= { LE_ITEM_ARMOR_LEATHER, LE_ITEM_ARMOR_GENERIC },
	[SPEC_MONK_WW]					= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_PALADIN_HOLY]				= { LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_GENERIC, LE_ITEM_ARMOR_SHIELD },
	[SPEC_PALADIN_PROT]				= { LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD },
	[SPEC_PALADIN_RET]				= { LE_ITEM_ARMOR_PLATE },
	[SPEC_PRIEST_DISC]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_PRIEST_HOLY]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_PRIEST_SHADOW]			= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_ROGUE_ASS]				= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_ROGUE_OUTLAW]				= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_ROGUE_SUB]				= { LE_ITEM_ARMOR_LEATHER },
	[SPEC_SHAMAN_ELE]				= { LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_GENERIC, LE_ITEM_ARMOR_SHIELD },
	[SPEC_SHAMAN_ENH]				= { LE_ITEM_ARMOR_MAIL },
	[SPEC_SHAMAN_RESTO]				= { LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_GENERIC, LE_ITEM_ARMOR_SHIELD },
	[SPEC_WARLOCK_AFF]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_WARLOCK_DEMO]				= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_WARLOCK_DESTRO]			= { LE_ITEM_ARMOR_CLOTH, LE_ITEM_ARMOR_GENERIC },
	[SPEC_WARRIOR_ARMS]				= { LE_ITEM_ARMOR_PLATE },
	[SPEC_WARRIOR_FURY]				= { LE_ITEM_ARMOR_PLATE },
	[SPEC_WARRIOR_PROT]				= { LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD }
}

EQUIPPABLE_WEAPON_BY_SPEC = {
	[SPEC_DK_BLOOD]					= { LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H },
	[SPEC_DK_FROST]					= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H },
	[SPEC_DK_UNHOLY]				= { LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H },
	[SPEC_DH_HAVOC]					= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_WARGLAIVE },
	[SPEC_DH_VENGEANCE]				= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_WARGLAIVE },
	[SPEC_DRUID_BALANCE]			= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED },
	[SPEC_DRUID_FERAL]				= { LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF },
	[SPEC_DRUID_GUARDIAN]			= { LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF },
	[SPEC_DRUID_RESTO]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED },
	[SPEC_HUNTER_BM]				= { LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_GUNS },
	[SPEC_HUNTER_MARKS]				= { LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_GUNS },
	[SPEC_HUNTER_SURVIVAL]			= { LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF },
	[SPEC_MAGE_ARCANE]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },
	[SPEC_MAGE_FIRE]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },
	[SPEC_MAGE_FROST]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },
	[SPEC_MONK_BM]					= { LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF },
	[SPEC_MONK_MW]					= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED },
	[SPEC_MONK_WW]					= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED },
	[SPEC_PALADIN_HOLY]				= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_SWORD2H },
	[SPEC_PALADIN_PROT]				= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H },
	[SPEC_PALADIN_RET]				= { LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H },
	[SPEC_PRIEST_DISC]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND },
	[SPEC_PRIEST_HOLY]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND },
	[SPEC_PRIEST_SHADOW]			= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND },
	[SPEC_ROGUE_ASS]				= { LE_ITEM_WEAPON_DAGGER },
	[SPEC_ROGUE_OUTLAW]				= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED },
	[SPEC_ROGUE_SUB]				= { LE_ITEM_WEAPON_DAGGER },
	[SPEC_SHAMAN_ELE]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED },
	[SPEC_SHAMAN_ENH]				= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_UNARMED },
	[SPEC_SHAMAN_RESTO]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED },
	[SPEC_WARLOCK_AFF]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },
	[SPEC_WARLOCK_DEMO]				= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },
	[SPEC_WARLOCK_DESTRO]			= { LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },
	[SPEC_WARRIOR_ARMS]				= { LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H },
	[SPEC_WARRIOR_FURY]				= { LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H },
	[SPEC_WARRIOR_PROT]				= { LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H }
}

function PLM_GetFullName(name)
	if name == nil then
		return nil
	elseif string.find(name, '-') then
		name = name:gsub("%s", "")
		return name
	else
		local name, realm = UnitFullName(name)
		if name == nil then
			return nil
		elseif realm == nil or realm == '' then
			name = name .. '-' .. GetRealmName()
			name = name:gsub("%s", "")
			return name
		else
			name = name .. '-' .. realm
			name = name:gsub("%s", "")
			return name
		end
	end
end

function IsPlayer(characterName)
	return characterName == 'player'
		or characterName == PLM_GetFullName('player')
		or characterName == UnitName('player')
end

function GetItemCountFromCache(name)
	local itemCount = 0
	if name ~= nil and groupInfoCache[name] ~= nil then
		for slotID, item in pairs(groupInfoCache[name]) do
			itemCount = itemCount + 1
		end
		itemCount = itemCount - 4 -- subtract 4 since everyone has CLASS_NAME, SPEC, LEVEL, and FORCE_REFRESH elements
	end
	return itemCount
end

function GetExpectedItemCount(spec)
	if SPECS_EXPECTED_TO_HAVE_OFFHAND[spec] then
		return 16
	else
		return 15
	end
end

function PLM_CreateEmptyTooltip(rows)
    local tooltip = CreateFrame('GameTooltip')
	local leftside = {}
	local rightside = {}
	local L, R
    for i = 1, rows do
        L, R = tooltip:CreateFontString(), tooltip:CreateFontString()
        L:SetFontObject(GameFontNormal)
        R:SetFontObject(GameFontNormal)
        tooltip:AddFontStrings(L, R)
        leftside[i] = L
		rightside[i] = R
    end
    tooltip.leftside = leftside
	tooltip.rightside = rightside
	tooltip:SetOwner(UIParent, 'ANCHOR_NONE')
    return tooltip
end

function GetILVLFromTooltip(tooltip)
	local ITEM_LEVEL_PATTERN = _G.ITEM_LEVEL:gsub('%%d', '(%%d+)')  -- Item Level (%d+)
	
	local ilvl = nil
	local text = tooltip.leftside[2]:GetText()
	if text ~= nil then
		ilvl = text:match(ITEM_LEVEL_PATTERN)
	end
	if ilvl == nil then  -- ilvl can be in the 2nd or 3rd line dependng on the tooltip; if we didn't find it in 2nd, try 3rd
		text = tooltip.leftside[3]:GetText()
		if text ~= nil then
			ilvl = text:match(ITEM_LEVEL_PATTERN)
		end
	end
	return ilvl
end

function ShouldBeEvaluated(fullItemInfo)
	return fullItemInfo[FII_IS_EQUIPPABLE]
		and (fullItemInfo[FII_QUALITY] == LE_ITEM_QUALITY_RARE or fullItemInfo[FII_QUALITY] == LE_ITEM_QUALITY_EPIC)
		and (fullItemInfo[FII_BIND_TYPE] == LE_ITEM_BIND_ON_ACQUIRE or (fullItemInfo[FII_BIND_TYPE] == LE_ITEM_BIND_ON_EQUIP)) -- ici pour lqe
end

function GetSlotID(itemEquipLoc)
	if itemEquipLoc == 'INVTYPE_HEAD' then return INVSLOT_HEAD
	elseif itemEquipLoc == 'INVTYPE_NECK' then return INVSLOT_NECK
	elseif itemEquipLoc == 'INVTYPE_SHOULDER' then return INVSLOT_SHOULDER
	elseif itemEquipLoc == 'BODY' then return INVSLOT_BODY
	elseif itemEquipLoc == 'INVTYPE_CHEST' then return INVSLOT_CHEST
	elseif itemEquipLoc == 'INVTYPE_ROBE' then return INVSLOT_CHEST
	elseif itemEquipLoc == 'INVTYPE_WAIST' then return INVSLOT_WAIST
	elseif itemEquipLoc == 'INVTYPE_LEGS' then return INVSLOT_LEGS
	elseif itemEquipLoc == 'INVTYPE_FEET' then return INVSLOT_FEET
	elseif itemEquipLoc == 'INVTYPE_WRIST' then return INVSLOT_WRIST
	elseif itemEquipLoc == 'INVTYPE_HAND' then return INVSLOT_HAND
	elseif itemEquipLoc == 'INVTYPE_FINGER' then return INVSLOT_FINGER1
	elseif itemEquipLoc == 'INVTYPE_TRINKET' then return INVSLOT_TRINKET1
	elseif itemEquipLoc == 'INVTYPE_CLOAK' then return INVSLOT_BACK
	elseif itemEquipLoc == 'INVTYPE_WEAPON' then return INVSLOT_MAINHAND
	elseif itemEquipLoc == 'INVTYPE_SHIELD' then return INVSLOT_OFFHAND
	elseif itemEquipLoc == 'INVTYPE_2HWEAPON' then return INVSLOT_MAINHAND
	elseif itemEquipLoc == 'INVTYPE_WEAPONMAINHAND' then return INVSLOT_MAINHAND
	elseif itemEquipLoc == 'INVTYPE_WEAPONOFFHAND' then return INVSLOT_OFFHAND
	elseif itemEquipLoc == 'INVTYPE_HOLDABLE' then return INVSLOT_OFFHAND
	elseif itemEquipLoc == 'INVTYPE_RANGED' then return INVSLOT_MAINHAND
	elseif itemEquipLoc == 'INVTYPE_THROWN' then return INVSLOT_MAINHAND
	elseif itemEquipLoc == 'INVTYPE_RANGEDRIGHT' then return INVSLOT_MAINHAND
	elseif itemEquipLoc == 'INVTYPE_TABARD' then return INVSLOT_TABARD
	else return nil
	end
end

function GetEquippedItem(characterName, slotID)
	local item = nil
	if IsPlayer(characterName) then
		item = GetInventoryItemLink('player', slotID)
	else
		local characterDetails = groupInfoCache[characterName]
		if characterDetails ~= nil then
			item = characterDetails[slotID]
		end
	end
	return item
end

function IsAnUpgrade(itemILVL, equippedItem, threshold)
	local equippedILVL = GetRealILVL(equippedItem)
--print("         drop ilvl = ", itemILVL)	
--print("         equippedILVL ilvl = ", equippedILVL)	
--print("         real equippedILVL ilvl = ", equippedILVL + threshold)	
	if equippedILVL == nil then  -- this means we couldn't find an equippedItem
		return false, 0
	else
		if threshold == nil then
			threshold = 0
		end
		return itemILVL > (equippedILVL + threshold), equippedILVL
	end
end

function GetRealILVL(item)
	local realILVL = nil
	
	if item ~= nil then
		tooltipShort = tooltipShort or PLM_CreateEmptyTooltip(3)
		tooltipShort:ClearLines()
		tooltipShort:SetHyperlink(item)

		realILVL = GetILVLFromTooltip(tooltipShort)
		if realILVL == nil then  -- if we still couldn't find it (shouldn't happen), just use the base ilvl we got from GetItemInfo()
			realILVL = select(4, GetItemInfo(item))
		end
	end
	
	return tonumber(realILVL)
end

function GetItemPrimaryAttribute(item)
	local stats = GetItemStats(item)
	if stats ~= nil then
		for stat, value in pairs(stats) do
			if _G[stat] == ITEM_MOD_STRENGTH_SHORT or _G[stat] == ITEM_MOD_INTELLECT_SHORT or _G[stat] == ITEM_MOD_AGILITY_SHORT then
				return _G[stat]
			end
		end
	end
	return nil
end

function IsCharacterInGroup(characterName)
	local index = 1
	local name = select(1, GetRaidRosterInfo(index))
	while name ~= nil do
		if name == characterName or PLM_GetFullName(name) == characterName then
			return true
		end
		index = index + 1
		name = select(1, GetRaidRosterInfo(index))
	end
	return false
end

function IsPLMUser(characterName)
	if plmUsers[characterName] ~= nil then
		return true
	else
		return false
	end
end

function PLM_GetNumberOfPLMUsers()
	local count = 0
	for _ in pairs(plmUsers) do
		count = count + 1
	end
	return count
end

function IsTrinketUsable(item, role)
	local itemLink = select(2, GetItemInfo(item))
	local itemID = string.match(itemLink, 'item:(%d+):')

	local trinketList = PLM_GetTrinketList(role)

	if itemID ~= nil and trinketList ~= nil then
		return trinketList[tonumber(itemID)]
	else
		return false
	end
end

function GetilvlDifference(lootedItem, characterName)
	local text = ''
	local isAnUpgrade, equippedILVL = EA_PLM:IsAnUpgradeForCharacter(lootedItem[FULL_ITEM_INFO], characterName, 0)
	if equippedILVL ~= 0 and lootedItem[FULL_ITEM_INFO][FII_REAL_ILVL] ~= 0 then
		local ilvlDifference = lootedItem[FULL_ITEM_INFO][FII_REAL_ILVL] - equippedILVL
		if ilvlDifference < 0 then
			text = " " .. ilvlDifference .. " ilvl"
		else
			text = " +" .. ilvlDifference .. " ilvl"
		end
	end
	return text
end

function PLM_DoHideItem(lootedItemIndex)
	local lootedItem = lootedItems[lootedItemIndex]
	lootedItem[STATUS] = STATUS_HIDDEN
	EA_PLM:UpdateDisplayFrame()
end



function parsePawnString(pawnstring)
	local Pos, _, Version, Name, ValuesString = strfind(pawnstring, "^%s*%(%s*Pawn%s*:%s*v(%d+)%s*:%s*\"([^\"]+)\"%s*:%s*(.+)%s*%)%s*$")

	if (not Pos) or (not Name) or (Name == "") or (not ValuesString) or (ValuesString == "") then return end
	
	local Values = {}
	local SpecID
	local function SplitStatValuePair(Pair)
		Pair = string.gsub(Pair, "%s+", "")
		print(Pair)
		local Pos, _, Stat, Value = strfind(Pair, "^%s*([%a%d]+)%s*=%s*(%-?[%d%.a-zA-Z]+)%s*,$")
		if Stat == "Class" then
			--Value = PawnGetClassIDFromName(Value)
		elseif Stat == "Spec" then
			--SpecID = Value
		else
			Value = tonumber(Value)
		end
		if Pos and Stat and (Stat ~= "") and Value then
			--print(Stat .. " = " .. stat_index[Stat] .. " = " .. Value)
			Values[stat_index[Stat]] = Value
		end
	end
	gsub(ValuesString .. ",", "[^,]*,", SplitStatValuePair)
	
	return Values
end

function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

function hasBonus(fullItemInfo)
	return fullItemInfo[FII_HAS_SOCKET]
		or fullItemInfo[FII_HAS_SPEED]
		or fullItemInfo[FII_HAS_LEECH]
		or fullItemInfo[FII_HAS_AVOIDANCE]
		or fullItemInfo[FII_HAS_INDESTRUCTIBLE]
end

function SendWhisp(lootedItem)
	msg = Config[PLM_WISP_MSG]
	msg_split = split(msg, "%item")
	msg = msg_split[1]:sub(1, -2) .. lootedItem[FULL_ITEM_INFO][FII_ITEM] .. msg_split[2]:sub(1, -2)
	SendChatMessage(msg, 'WHISPER', nil, Ambiguate(lootedItem[LOOTER_NAME], 'mail'))
	
end

function has_value(tab, val)
    for index, value in ipairs(tab) do
		value = split(value, " ")
        if value[1] == val then
            return true
        end
    end

    return false
end


function debug_print_cache(characterName)
		local num_characters = 0
		local item_msg = ''
		local force = false
		for name, characterDetails in pairs(groupInfoCache) do
			num_characters = num_characters + 1
			local countfromcache = GetItemCountFromCache(name)
			item_msg = item_msg .. countfromcache .. '/ ' 
			if countfromcache < 15 then
				force =  true
			end
		end
		--print('Cache contains ' .. num_characters .. ' member(s). Item count per member: ' .. item_msg)
		if force == true then
			EA_PLM:PopulateGroupInfoCache()
		end
		
		if (characterName ~= nil) then
			for name, details in pairs(groupInfoCache) do
				--print('   ' .. name .. ' ' .. GetItemCountFromCache(name) .. ' items')
				if name == PLH_GetFullName(characterName) then
					if details == nil then	
						--print('      details is nil')
					else
						for slotID, item in pairs(details) do
							--print('      ' .. slotID .. ' = ' .. tostring(item))
						end
					end
				end
			end
		end
end
